#!/usr/bin/env python
# -*- coding: UTF-8 -*-

import xml.dom.minidom

class MediaReader:
	"""Reads the content of the '../data/media.xml' file. Its aim is to
	return a list containing all of the indices of the media. """

	def __init__(self):
		self.ids = []
		self.axes = []
		self.setIds()
		self.setAxes()


	def setIds(self):
		root = xml.dom.minidom.parse("../data/media.xml").childNodes[0]
		media = root.childNodes
		for elmt in media:
			for attr in elmt.childNodes:
				if (attr.localName == "id"):
					self.ids.append(attr.firstChild.data)


	def setAxes(self):
		root = xml.dom.minidom.parse("../data/config.xml").childNodes[0]
		media = root.childNodes
		for elmt in media:
			if (elmt.localName == "axes"):
				for attr in elmt.childNodes:
					if (attr.localName == "axis"):
						self.axes.append(attr.firstChild.data)


	def getIds(self):
		return self.ids


	def getAxes(self):
		return self.axes


	def testClass(self):
		"""Prints the list of the identifers found in order for you to
		check if they all are present."""
		res = "identifiers found:\n"
		for i in self.ids:
			res += str(i) + ", "
		res += "\n\naxes found:\n"
		for a in self.axes:
			res += a + ", "
		print res


# --------------- TEST

if (__name__ == "__main__"):
	mr = MediaReader()
	mr.testClass()
