#!/usr/bin/env python
# -*- coding: UTF-8 -*-

import json
import urllib

class ResultsUploader:
	"""Writes the content of a dictionnary in a JSON formatted file in
	order to upload it to the anteChamber."""

	def __init__(self,jobid):
		self.content = {
			"judgments_per_unit":3,
			"js":"",
			"instructions":"You have to look carefully at hose images. A question about them will be asked lower on this page.",
			"included_countries":[],
			"auto_order":True,
			"state":"unordered",
			"min_unit_confidence":None,
			"custom_key":None,
			"completed":False,
			"confidence_fields":["which_one_of_these_two_images_conveys_the_most_axis_"],
			"language":"en",
			"auto_order_threshold":None,
			"title":"Comparison of the emotion conveyed by two images",
			"results":
			{
				"judgments": []
			},
			"gold":{},
			"created_at":"2011-06-23T12:59:47+00:00",
			"units_count":187,
			"completed_at":None,
			"max_unit_confidence":None,
			"pages_per_assignment":None,
			"gold_per_assignment":0,
			"css":"",
			"golds_count":0,
			"units_per_assignment":10,
			"judgments_count":0,
			"max_judgments_per_worker":None,
			"send_judgments_webhook":None,
			"fields":
			{
				"which_one_of_these_two_images_conveys_the_most_axis_":"agg"
			},
			"webhook_uri":"http://ns204207.ovh.net/videosense/webhook/main.php",
			"id":jobid,
			"excluded_countries":[],
			"updated_at":"2011-06-23T12:59:52+00:00",
			"max_judgments_per_unit":None,
			"options":
			{
				"mail_to":None,
				"amt_url":None,
				"keywords":"comparisons,movie shots"
			}
		}
		self.judgements = []


	def addJudgement(self,judg):
		"""Adds the judg judgement to the 'judgements' attribute."""
		#print "\n\n----------------\n",judg["worker_id"],judg["data"]["axis"],judg["id"]
		self.judgements.append(judg)
		#for j in self.judgements:
		#	print "\t",j["worker_id"],j["data"]["axis"],j["id"]


	def printJSON(self,path2file):
		"""Prints the content of the 'content' attribute in a JSON
		formatted file located in 'path2file'."""
		self.content["results"]["judgments"] = self.judgements
		jsonFile = open(path2file,'w')
		jsonContent = json.dumps(self.content, indent=4)
		jsonFile.write(jsonContent)
		jsonFile.close()


	def uploadFile(self,path2file,url):
		"""Uploads the file at 'path2file' to the 'url' address using a
		HTTP POST. Returns """
		payload = open(path2file,'r').read()
		params = urllib.urlencode({'signal':'job_complete', 'payload': payload })
		conn = urllib.urlopen(url, params)
		response = conn.read()
		print response
		conn.close()


	def testClass(self,url):
		"""Uses the printJSON method to see if it works."""
		self.printJSON("../data/CM-stub/testJSON.json")
		print "file written: ../data/CM-stub/testJSON.json"
		self.uploadFile("../data/CM-stub/testJSON.json",url)


# --------------- TEST

if (__name__ == "__main__"):
	rw = ResultsUploader(0)
	rw.addJudgement( {
				"started_at":"2011-06-23T12:59:51+00:00",
				"created_at":"2011-06-23T12:59:51+00:00",
				"worker_id":"jeanJacques",
				"unit_id":1338,
				"judgment":"Image 2",
				"ip":"0.0.0.0",
				"data":
				{
					"axis":"axe1",
					"urlmedia1":"truc96.ogg",
					"urlmedia2":"truc97.ogg",
					"idmedia1":"96",
					"idmedia2":"97"
				},
				"id":84539562,
				"which_one_of_these_two_images_conveys_the_most":
				{
					"agg":"Image 2",
					"confidence":"0.8"
				}
			})
	rw.testClass("http://ns204207.ovh.net/videosense/antechamber/main.php")
