<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<?php
		include('manUtils.php');
		manHeader('Antechamber');
		manMenu("antechamber.php");
	?>


	<h2>Antechamber ?</h2>
	<div class="diagramm">
		<p>In older days, one had to go through a gentleman's antechamber and wait here until he could see him. The same applies here: rough results sent by crowdflower will be waiting here before they are retrieved by CPS. To further the analogy, this component will warn you when results are are waiting for you (just like a servant) and prepare them for you.</p>
		<p>As stated above, these are the two functions of this component:</p>
		<ul>
			<li>Receive the results from CrowdFlower, store them and parse them: while CPS can read <a href="https://secure.wikimedia.org/wikipedia/en/wiki/Comma-separated_values">csv files</a>, it can <em>not</em> read <a href="https://secure.wikimedia.org/wikipedia/en/wiki/JSON">JSON</a>. <a href="thankYouCF.php">Why ?</a></li>
			<li>Send you a notification e-mail when results are ready, <em>i.e</em> when you can launch a new iteration.</li>
		</ul>
	</div>


	<h2>Mail Address</h2>
	<div class="diagramm">
		<p>You have to edit the <tt>main.php</tt> file of the antechamber in order for the <tt>$address</tt> variable to contain yours.
	</div>


	<h2>From JSON to CSV</h2>
	<div class="diagramm">
		<p>As stated in the introduction, it is necessary to change the format of the result file from JSON to CSV. This is done using PHP's JSON parser, <tt>json_decode</tt>, which converts a JSON formatted string into an array. Here is the function:</p>
		<div class="fragment"><pre class="fragment">
00001	<span class="keyword">function</span> json2csv($content,$path)
00002	<span class="comment">/* Transforms the JSON formatted string $content in a csv fomatted</span>
00003	<span>* one and prints it in the file whose path is $path. */</span>
00004	{
00005		echo '$content:'.$content.<span class="charliteral">"\n"</span>;
00006		$jsonInput = json_decode($content,true);
00007		 <span class="comment">// echo <span class="charliteral">"\n"</span>.'job_id:'.$jsonInput['id'].<span class="charliteral">"\n"</span>;</span>
00008		
00009		$res = '_unit_id,_created_at,_id,_started_at,_trust, _worker_id,_country,_region,_city,_ip,which_media_conveys_the_most,idMedia1,idMedia2,axis,urlmedia1,urlmedia2'.<span class="charliteral">"\n"</span>;
00010		$j = $jsonInput["results"]["judgments"];
00011		$count = count($j);
00012		<span class="keywordflow">for</span>($i=0;$i<$count;$i++)
00013		{
00014			 <span class="comment">//  initialisation</span>
00015			$line = '';
00016			<span class="comment">// building line</span>
00017			$line .= $j[$i][<span class="stringliteral">"unit_id"</span>].<span class="stringliteral">'.'</span>;
00018			$line .= $j[$i][<span class="stringliteral">"created_at"</span>].<span class="stringliteral">'.'</span>;
00019			$line .= $j[$i][<span class="stringliteral">"started_at"</span>].<span class="stringliteral">'.'</span>;
00020			$line .= $j[$i][<span class="stringliteral">"id"</span>].<span class="stringliteral">'.'</span>;
00021			$line .= $j[$i][<span class="stringliteral">"which_media_conveys_the_most"</span>]["confidence"].<span class="stringliteral">'.'</span>;
00022			$line .= $j[$i][<span class="stringliteral">"worker_id"</span>].<span class="stringliteral">'.'</span>;
00023			$line .= $j[$i][<span class="stringliteral">"country"</span>].<span class="stringliteral">'.'</span>;
00024			$line .= $j[$i][<span class="stringliteral">"region"</span>].<span class="stringliteral">'.'</span>;
00025			$line .= $j[$i][<span class="stringliteral">"city"</span>].<span class="stringliteral">'.'</span>;
00026			$line .= $j[$i][<span class="stringliteral">"ip"</span>].<span class="stringliteral">'.'</span>;
<span class="comment">00027</span>			<strong>$line .= $j[$i][<span class="stringliteral">"judgment"</span>].<span class="stringliteral">'.'</span></strong>;
00028			 <span class="comment">// adding the content of the 'data' field:</span>
00029			$line .= $j[$i][<span class="stringliteral">"data"</span>][<span class="stringliteral">idmedia1"</span>].<span class="stringliteral">'.'</span>;
00030			$line .= $j[$i][<span class="stringliteral">"data"</span>][<span class="stringliteral">idmedia2"</span>].<span class="stringliteral">'.'</span>;
00031			$line .= $j[$i][<span class="stringliteral">"data"</span>][<span class="stringliteral">"axis"</span>].<span class="stringliteral">'.'</span>;
00032			$line .= $j[$i][<span class="stringliteral">"data"</span>][<span class="stringliteral">"urlmedia1"</span>].<span class="stringliteral">'.'</span>;
00033			$line .= $j[$i][<span class="stringliteral">"data"</span>][<span class="stringliteral">"urlmedia2"</span>].<span class="stringliteral">'.'</span>;
00034			 <span class="comment">// adding the line to the results</span>
00035			$res .= $line.<span class="charliteral">"\n"</span>;
00036			echo $line.<span class="charliteral">"\n"</span>;
00037		}
00038		save($res,$path);
00039	}
		</pre></div>
	</div>

	<h2>Configuration</h2>
	<div class="diagramm">
		<p>As you could see above, the <tt>json2csv</tt> method easily transforms a JSON formatted file into a CSV formatted one.However, <strong>its configuration is not definitive!</strong> Indeed, I could not find a way to know for sure the field in which the answer to the question the workers are asked is stored. Therefore, <strong>you may have to edit this function!</strong></p>
		<p>If such a modification is necessary, it must be made at the line 27 of the function by replacing
		<pre class="fragment">$j[$i]["judgment"]</pre> by
		<pre class="fragment">$j[$i]["where the judgment actually is"]</pre>
		</p>
		<p>In order to know where it is, look at a json formatted results file you retrieved and locate a field containing either <tt>"Media 1"</tt>, <tt>"Media 2"</tt> or anything else the turkers may answer to your question. The possible answers are set in the <a href="cml.php">CML template</a>.</p>
		<p>Once your modification is complete, go to the antechamber, at the page where you can see your JSON files (<em>i.e</em> <tt>Raw Results</tt>), select the file you just received in the menu below and click on "<tt>Tranform it!</tt>". It will regenerate the corresponding csv file correctly.</p>
	</div>

	<h2>Notification mail</h2>
	<div class="diagramm">
		<p>When CrowdFlower gathered all the judgements necessary for a <tt>job</tt> (<em>i.e</em>, the group of comparisons uploaded all at once), it will post a <a href="https://crowdflower.com/docs/api/webhooks/">webhook</a> at an adress you set. These are used by the antechamber to know when to send you an e-mail inviting you to perform a new iteration. However, since webhooks are also supposed to be sent when each <tt>unit</tt> (one of the comparison CPS asked for) have all the judgements it needs, it also filters them: you probably don't want your mailbox to be filled with thousands of mail within days...</p>
	</div>


	<h2>How it works</h2>
	<div class="diagramm">
		<div class="explanations"><em>Note:</em> You have to set the address of the <tt>main.php</tt> script of the antechamber as the one where webhooks are fired by CrowdFlower if you want his to work (and you most likely do).</div>
		<p>The way the PHP scripts deal with webhooks is pretty straight forward: when a Webhook is received, its <tt>payload</tt> is decoded using <tt>json_decode()</tt>. Then, depending on the value of the <tt>signal</tt> attribute, different things can happen:</p>
		<ul>
			<li>If it corresponds to the end of a job <tt>($signal === 'job_complete')</tt>:
				<ol>
					<li>The identifier of the job is retrieved.</li>
					<li>The content of the webhook, <em>i.e</em> its <tt>payload</tt> attribute, is saved in <tt>webhook.json</tt>.</li>
					<li>It is then parsed in order for it to be transformed into a csv file.</li>
					<li>An email is sent to the user.</li>
				</ol>
			</li>
			<li>
				Otherwise, if it spots the end of a splitsort <tt>($signal === 'sort_finished')</tt>, here is what happens (quch a webhook is sent by CPS itself, not by CrowdFlower):
				<ol>
					<li>An email is sent at the address you have set with the content of the <tt>payload</tt> as an attachment (it should the <a href="xmlFiles.php"><tt>results.xml</tt></a> file.</li>
					<li>The identifier of the results file is calculated: it is the date when it was retrieved.</li>
					<li>This file is saved.</li>
				</ol>
			</li>
		</ol>
		<p>In every case, the date and hour of the post are stored in a logfile, as well as the value of the <tt>signal</tt> attribute.</p>
		<div class="fragment"><pre class="fragment">
include(<span class="stringliteral">'webhookUtils.php'</span>);

<span class="comment">// YOUR ADDRESS:</span>span>
$address = <span class="stringliteral">'leo.perrin@ecl2012.ec-lyon.fr'</span>;

<span class="keywordflow">if</span> (isset($_POST[<span class="stringliteral">'signal'</span>]))
{
	$jsonPayload = json_decode($_POST[<span class="stringliteral">'payload'</span>],true);
	$triggerIteration = <span class="stringliteral">'job_complete'</span>;
	$triggerFinished = <span class="stringliteral">'sort_finished'</span>;
	<span class="keywordflow">if</span> ($_POST[<span class="stringliteral">'signal'</span>] === $triggerIteration)
	{
		$job_id = $jsonPayload[<span class="stringliteral">"id"</span>];
		save($_POST[<span class="stringliteral">'payload'</span>],<span class="stringliteral">'raw/'</span>.$job_id.<span class="stringliteral">'.json'</span>);
		json2csv($jsonPayload,<span class="stringliteral">'csv/'</span>.$job_id.<span class="stringliteral">'.txt'</span>);
		echo <span class="stringliteral">'Parsing of the JSON file finished: sending notification email.'</span>.<span class="charliteral">"\n"</span>;
		jobCompleteNotification($address,$job_id);
	}
	<span class="keywordflow">else if</span> ($_POST[<span class="stringliteral">'signal'</span>] === $triggerFinished)
	{
		finishedNotification($address,$_POST[<span class="stringliteral">'payload'</span>]);
		echo <span class="stringliteral">'Sort Finished: sending notification mail.'</span>.<span class="charliteral">"\n"</span>;
		$job_id = date(<span class="stringliteral">'Ymd-Hi'</span>).<span class="stringliteral">'-CPS_results.xml'</span>;
		save($_POST[<span class="stringliteral">'payload'</span>],<span class="stringliteral">'finalResults/'</span>.$job_id);
	}
	<span class="keywordflow">else</span>
		$job_id = $jsonPayload[<span class="stringliteral">"job_id"</span>];
	append2log($_POST[<span class="stringliteral">'signal'</span>],$job_id);
}
		</pre></div>
	</div>


	<?php
		printFooter();
	?>
</html>
