<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<?php
		include('manUtils.php');
		manHeader('CML (job template)');
		manMenu("cml.php");
	?>

	<h2>CML ? What is it ?</h2>
	<div class="diagramm">
		<p>If you use CPS, you want humans to perform comparisons in order to sort media. But in order them to do so, you must first ask them! Therefore, you will have to design a small web page displaying your media and asking workers to compare them. This where <a href="https://crowdflower.com/docs/cml">cml</a> enters.</p>
		<p>CrowdFlower Markup Language is a modified version of html allowing you to easily ask questions. It also allows CrowdFlower to retrieve their results in order them to be sent to you, so you definitely have to use cml.</p>
	</div>

	<h2>Examples</h2>
	<div class="diagramm">
	<p>While CrowdFlower's <a href="https://crowdflower.com/docs/cml">documentation on cml</a> is rather clear, a few examples could never hurt.</p>
	<ul>
		<li><a href="files/imageCML.txt">Here</a> is a cml template asking for the comparison of two images. Be carefull if you plan to use it: the size of the images is modified inside < img> marks, so you would better make sure they all have the same size.</li>
		<li>
			And <a href="files/videoCML.txt">here</a> is another cml template asking for the comparison of two videos hosted on youtube. It is pretty much the same as the other one, except that < img> marks are replaced by youtube's embedded <a href="https://secure.wikimedia.org/wikipedia/en/wiki/Adobe_Flash_Player">flash player</a>.
			<div class="explanations">
				<em>Note:</em> If want to compare short movies but do not want to host them somewhere else, you can use your own flashplayer. I recommand <a href="http://flv-player.net/players/normal/">flv-player</a>: it is very easy to use and works well. All you have to do is put the given <tt>.swf</tt> file on your server; then you can you diplay your videos using the following code:
				<pre class="fragment">
< object type="application/x-shockwave-flash" data="$THE_COMPLETE_URL_OF_YOUR_FLV-PLAYER" width="320" height="240">
	< param name="movie" value="$THE_COMPLETE_URL_OF_YOUR_FLV-PLAYER" />
	< param name="FlashVars" value="flv=$THE_COMPLETE_URL_OF_YOUR_OWN_VIDEO" />
< /object>
				</pre>
				Where:
				<ul>
					<li><tt>$THE_COMPLETE_URL_OF_YOUR_FLV-PLAYER</tt> is... the complete URL of your own flv-player, <em>i.e</em> the address of your server and the path to the <tt>.swf</tt> file.</li>
					<li><tt>$THE_COMPLETE_URL_OF_YOUR_OWN_VIDEO</tt> is the same, but for your video. You should not use relative links.</li>
				</ul>
				<p><strong>Don't forget to remove the space at the beginning of the HTML marks in this example!</strong></p>
				<p>An example of a cml file using this flashplayer can be found <a href="files/myflash.txt">here</a></p>
			</div>
		</li>
	</ul>
	</div>

	<?php printFooter(); ?>
</html>
