<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<?php
		include('manUtils.php');
		manHeader('How To');
		manMenu("howto.php");
	?>


	<h2>Start</h2>
	<div class="diagramm">
	<p>
		Before going any further, you should double check that everything specified in the different <a href="check.php">check lists</a> provided here is set. From now, it will be assumed that it is the case.
	</p>
	<p>
		CPS uses a Command-Line Interface (<a href="https://secure.wikimedia.org/wikipedia/en/wiki/Command-line_interface">CLI</a>). Therefore, you must be able to use the command-line of the computer hosting CPS (for example via <a href="https://secure.wikimedia.org/wikipedia/en/wiki/Secure_Shell">ssh</a>). First, you need do move to the <tt>cps</tt> direction, the one in which you can see the <tt>bin</tt> folder:
		<div class="shell">cd 'cps direction'</div>
		A list of the argument CPS accepts is given if you simply call it without any arguments:
		<div class="shell">$> java -cp 'bin/:lib/*' myShell.MainClass</div>
		You can also you use the classical one, <tt>--help</tt>:
		<div class="shell">$> java -cp 'bin/:lib/*' myShell.MainClass --help</div>
	</p>
	<div class="explanations">
		<p><em>Note: If you run a <a href="https://secure.wikimedia.org/wikipedia/en/wiki/GNU_Linux">GNU/Linux</a> or <a href="https://secure.wikimedia.org/wikipedia/en/wiki/Bsd">BSD</a> based operating system (If you don't ... here's another reason why you should!), you can simply use <tt>"./cps.sh"</tt> instead of <tt>"java -cp 'bin/:lib/*' myShell.MainClass"</tt>:</em>
		<div class="shell">./cps.sh</div></p>
	</div>
	<p>
		Each time it is launched, no matter what the arguments are, CPS creates a log file in the <tt>data/log/</tt> directory. You can check it to find more information in case CPS encounters a problem.
	</p>
	</div>


	<h2>Checks</h2>
	<div class="diagramm">
		<p>CPS provides several fonctions allowing different modules to be checked. You will find below a list of how to perform these checks and how they work. You should perform these tests in the order given below. Indeed, for instance, if <tt>--check config</tt> says there is a problem, it may be the cause of those you could encounter when asking for <tt>--check sql-db</tt>.</p>
		<ul>
			<li>
				<h3><tt>config</tt></h3>
				<p>To check if the <a href="xmlFiles.php"><tt>config.xml</tt></a> file contains all the information necessary to continue, you should use this command:
				<div class="shell">$> java -cp 'bin/:lib/*' myShell.MainClass --check config</div>
				It will use the <a href="../doxygen/html/classmyShell_1_1Interpreter.html#a9e6507e6cd99a4101b73e29b9d6c732a"><tt>Interpreter.checkFile()</tt></a> static method to see if all the nodes are present.</p>
			</li>
			<li>
				<h3><tt>sql-db</tt></h3>
				<p>To check the communication between CPS and the MySQL database, you should use this command:
				<div class="shell">$> java -cp 'bin/:lib/*' myShell.MainClass --check sql-db $PASSWORD</div>
				Where <tt>$PASSWORD</tt> is the password of the MySQL database for the user specified in the <a href="xmlFiles.php"><tt>config.xml</tt></a> file.
				It will construct a <a href="../doxygen/html/classmyDataBases_1_1MySQLbase.html"><tt>MySQLbase</tt></a> instance and ask it to create a connection with the database. The output of this command will tell you if everything works fine... or not.</p>
			</li>
			<li>
				<h3><tt>newjob</tt></h3>
				<p>During each <a href="../principle/principle.php">splitsort</a> iteration, a new <a href="https://crowdflower.com/docs/api/jobs/">job</a> is created at CrowdFlower by copying the one whose Id is specified in the <a href="xmlFiles.php"><tt>config.xml</tt></a> file. In order to check if this step can be done without a problem, you should use the following command:
				<div class="shell">$> java -cp 'bin/:lib/*' myShell.MainClass --check newjob</div>
				In doing so, you ask CPS to call <a href="../doxygen/html/classcrowdUser_1_1CrowdManager.html#aaa4487b75e4ce36d7de0178664cb34c0"><tt>CrowdManager.createNewJob()</tt></a>, which will... create a new job. Again, to see if everything worked well, look at the output or at the log file.</p>
			</li>
			<li>
				<h3><tt>final-email</tt></h3>
				<p>When the splitsort is over, CPS asks (<em>via</em> an HTTP request) the <a href="../principle/antechamber.php">antechamber</a> to send you an e-mail with the <a href="xmlFiles.php"><tt>results.xml</tt></a> file as an attachment. In order to test this feature, you should use this command:
				<div class="shell">$> java -cp 'bin/:lib/*' myShell.MainClass --check final-email</div>
				If the mail address you gave in the <tt>antechamber</tt> is correct and if the address of the antechamber set in the <a href="../userManual/xmlFiles.php"><tt>config.xml</tt></a> file is correct, you should receive very soon an email containing fake results.</p>
			</li>
		</ul>
	</div>


	<h2>Splitsort!</h2>
	<div class="diagramm">
		<p>All right, everything works fine and you have triple checked your check lists? Then it is time to talk business: in this part, you will see how to place your media along the axes you want.</p>
		<ul>
			<li>
				<p>First, you must <em>start</em> the splitsort. For this, you must you the following command:
				<div class="shell">$> java -cp 'bin/:lib/*' myShell.MainClass --new $PASSWORD</div>
				Where <tt>$PASSWORD</tt> is the password of the MySQL database for the user specified in the <a href="xmlFiles.php"><tt>config.xml</tt></a> file.</p>
				<p>This will perform the first half of a splitsort iteration. For more details on what exactly happens here, you can check the UML diagramms in <a href="../principle/uml.php">this page</a>.</p>
			</li>
			<li>
				<p>Now that a new splitsort started, you will have to perform iteration. These are manually launched, so you will have to run other commands. <strong>You will eventually receive an e-mail asking you to start a new iteration when results are ready to be downloaded.</strong> Well, provided that you correctly configured the <a href="../principle/components.php"><tt>antechamber</tt></a>...</p>
				<p>Once you have received this e-mail from CPS, you should run the following command:
				<div class="shell">$> java -cp 'bin/:lib/*' myShell.MainClass --iteration $PASSWORD</div>
				This will start a complete iteration: downloading of the results, interpretation, quicksort iteration, generation of new comparisons, generation of the data for the corresponding job, creation of a new job and upload of data to feed it. Once it is done, all you have to do is waiting for another e-mail telling you that you have to launch a new iteration (or that it is over). Again, more details can be found <a href="../principle/principle.php">here</a> and <a href="../principle/uml.php">there</a>.</p>
			</li>
			<li>
				<p>You will know that the splitsort is finished when you receive an email from CPS containing a <a href="xmlFiles.php"><tt>results.xml</tt></a> file. If, for some reason, you can not read the attachment, an address from which you can download this file will be given in the mail. You will be able to find it <a href="../antechamber/finalRestuls.php">here</a>.</p>
			</li>
		</ul>
	</div>

	<?php
		printFooter();
	?>
</html>
