<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<?php
		include('manUtils.php');
		manHeader('Tree View');
		manMenu("tree.php");
	?>

	<h2>Introduction</h2>
	<div class="diagramm">
		<p>The tree view of CPS contains quite a lot of directories. The aim of this section is to give a quick overview of what each one of them is for.</p>
		<p>It is divided in two parts, each one being dedicated to one of the main folders: <tt>cps</tt> and <tt>data</tt>.</p>
	</div>


	<h2>cps</h2>
	<div class="diagramm">
		This folder contains the classical java tree-view:
		<ul>
			<li>
				<h3>src</h3>
				<p>This is where the source files (with the <tt>.java</tt> extension) are stored. Their content is detailed in a <a href="../doxygen/html/index.html">dedicated</a> part of this website.</p>
			</li>
			<li>
				<h3>doc</h3>
				<p>This ones contains the <a href="../documentation/javadoc.php">Javadoc</a> of CPS. This folder is classical for <a href="https://secure.wikimedia.org/wikipedia/en/wiki/Java_%28language%29">Java</a> projects and it allows softwares like <a href="https://secure.wikimedia.org/wikipedia/en/wiki/Eclipse_%28software%29">Eclipse</a> to display it while you are coding.</p>
			</li>
			<li>
				<h3>doxygen</h3>
				<p>Contains all the data necessary for <a href="http://www.stack.nl/~dimitri/doxygen/">doxygen</a> to work, <em>i.e</em> a configuration file, a script launching the creation of the documentation and a folder containing additional files, such as the header to use.</p>
			</li>
			<li>
				<h3>lib</h3>
				<p>This folder contains the external library used by CPS, for example <a href="http://www.ibm.com/developerworks/java/library/j-jdom/">jdom</a> (used to parse and write xml files).</p>
			</li>
			<li>
				<h3>bin</h3>
				<p>At last, this folder contains the <a href="https://secure.wikimedia.org/wikipedia/en/wiki/Bytecode">bytecode</a> resulting from the compilation of the source files.</p>
			</li>
		</ul>
		It also contains a script, <tt>cps.sh</tt> allowing UNIX-like users to avoid typing "<tt>java -cp 'bin/:lib/*' myShell.MainClass</tt>" every time they use CPS.
	</div>

	<h2>data</h2>
	<div class="diagramm">
		This is where useful data is stored, as well as a stub to allow easy testing and other scripts. First, let's take a look at the files stored here:
		<ul>
			<li>
				<h3>config.xml</h3>
				<p>More details on what this is used for <a href="xmlFiles.php">here</a>.</p>
			</li>
			<li>
				<h3>media.xml</h3>
				<p>More details on what this is used for <a href="xmlFiles.php">here</a>.</p>
			</li>
		</ul>
		Now, here is a list of all the folders you will find here:
		<ul>
			<li>
				<h3>HITdata</h3>
				<p>CPS will write the <a href="https://secure.wikimedia.org/wikipedia/en/wiki/Comma-separated_values">csv files</a> to upload to CrowdFlower here. You should not have to touch anything here.</p>
			</li>
			<li>
				<h3>HITresults</h3>
				<p>This is where CPS will write the results downloaded from CrowdFlower. The download, the extraction of the file and its renaming are performed in one operation.</p>
			</li>
			<li>
				<h3>log</h3>
				<p>No matter what the arguments specified are, CPS will create a log file here when you launch it. The name of the log files have the following structure, describing the time at which it was started: <tt>dd-mm-yyyy-(hh-mm-ss).log</tt>, where:
				<ul>
					<li><tt>dd</tt> is the number of the day</li>
					<li>The first <tt>mm</tt> is the number of the month</li>
					<li><tt>yyyy</tt> is the complete number of the year</li>
					<li><tt>hh</tt> is the hour</li>
					<li>The second <tt>mm</tt> is the minute</li>
					<li><tt>ss</tt> is the second</li>
				</ul>
				<div class="explanations"><em>Note: Even if you are continuing an ongoing splitsort using the <em><a href="howto.php"><tt>--iteration</tt></a></em> argument, a <em>new</em> log file will be created.</em></div>
				</p>
			</li>
			<li>
				<h3>previously</h3>
				<p>In order to be able to start again where he left, CPS stores the intermediary results of the sort in this folder. Therefore, if a splitsort is running, it will contain a file for each axis studied. It also contains a tiny file simply containing the number of the job from where results should be retrieved.</p>
			</li>
			<li>
				<h3>mysql</h3>
				<p>This folder contains data used to interact with the MySQL database. The most important is the <tt>dump.sh</tt> script performing the dump of the database.</p>
			</li>
		</ul>
	</div>
	<?php
		printFooter();
	?>
</html>
